# -*- coding: utf-8 -*-
from setuphelpers import *
import time

uninstallkey = []

# Source    ftp://ftp.adobe.com/pub/adobe/reader/win/AcrobatDC/

args = '/sAll /msi /norestart /quiet ALLUSERS=1 EULA_ACCEPT=YES UPDATE_MODE=0 DISABLE_ARM_SERVICE_INSTALL=1 DISABLEDESKTOPSHORTCUT=1'

def install():

    if uninstall_key_exists('{AC76BA86-7AD7-1036-7B44-AC0F074E4100}'):
        killalltasks(['AdobeARM.exe','AcroRd32.exe'])
        run(uninstall_cmd('{AC76BA86-7AD7-1036-7B44-AC0F074E4100}'))

    print('installation Adobe Reader MUI')
    versionpaquet = control['version'].split('-',1)[0]
    versionsoft = versionpaquet[2:]

    if need_install('{AC76BA86-7AD7-FFFF-7B44-AC0F074E4100}'):
        killalltasks(['AdobeARM.exe','AcroRd32.exe'])
        run(r'"AcroRdrDC1901020064_MUI.exe" %s' % args,timeout=1200)

    if need_install('{AC76BA86-7AD7-FFFF-7B44-AC0F074E4100}'):
        error('AcroRdrDC1901020064_MUI.exe not install correctly')

    filemsp = glob.glob('*.msp')[0]

    if need_install('{AC76BA86-7AD7-FFFF-7B44-AC0F074E4100}',min_version=versionsoft):
        killalltasks(['AdobeARM.exe','AcroRd32.exe'])
        run('msiexec.exe /p %s /norestart /quiet ALLUSERS=1 EULA_ACCEPT=YES' % filemsp,timeout=1200)
    else:
        print('%s Already install -- Skipped' % filemsp)

    uninstallkey.append('{AC76BA86-7AD7-FFFF-7B44-AC0F074E4100}')

    if need_install('{AC76BA86-7AD7-FFFF-7B44-AC0F074E4100}',min_version=versionsoft):
        error('%s not install correctly' % filemsp)

    print("desactivation des mises a jour automatiques")
    if iswin64():
        key=reg_openkey_noredir(HKEY_LOCAL_MACHINE,r'SOFTWARE\Wow6432Node\Adobe\Adobe ARM\1.0\ARM',sam=KEY_WRITE,create_if_missing=True)
        reg_setvalue(key,'icheckReader',0,REG_DWORD)
    else:
        key=reg_openkey_noredir(HKEY_LOCAL_MACHINE,r'SOFTWARE\Adobe\Adobe ARM\1.0\ARM',sam=KEY_WRITE,create_if_missing=True)
        reg_setvalue(key,'icheckReader',0,REG_DWORD)

    key=reg_openkey_noredir(HKEY_LOCAL_MACHINE,r'SOFTWARE\Policies\Adobe\Acrobat Reader\DC\FeatureLockDown',sam=KEY_WRITE,create_if_missing=True)
    reg_setvalue(key,'bUpdater',0,REG_DWORD)

    #suppression des tache planifer adobe
    if "Adobe Acrobat Update Task" in run('schtasks') :
        run('schtasks /Delete /tn "Adobe Acrobat Update Task" /f')

    #suppression du service AdobeARMservice
    if service_installed('AdobeARMservice'):
        if service_is_running('AdobeARMservice'):
            service_stop('AdobeARMservice')
            time.sleep(5)
        run('sc delete AdobeARMservice')

    # attention l'espace n'est pas un espace u'Acrobat Reader\xa0DC.lnk'
    remove_desktop_shortcut(u'Acrobat Reader DC.lnk')


def session_setup():
   registry_setstring(HKEY_CURRENT_USER, r"SOFTWARE\Adobe\Acrobat Reader\DC\JSPrefs",'bEnableGlobalSecurity',1,type=REG_DWORD)
   registry_setstring(HKEY_CURRENT_USER, r"SOFTWARE\Adobe\Acrobat Reader\DC\JSPrefs",'bEnableJS',0,type=REG_DWORD)
   registry_setstring(HKEY_CURRENT_USER, r"SOFTWARE\Adobe\Acrobat Reader\DC\Originals",'bAllowOpenFile',0,type=REG_DWORD)

def update_package():


    proxies = {}
    if isfile(makepath(user_local_appdata(),'waptconsole','waptconsole.ini')):
        proxywapt = inifile_readstring(makepath(user_local_appdata(),'waptconsole','waptconsole.ini'),'global','http_proxy')
        if proxywapt :
            proxies = {'http':proxywapt,'https':proxywapt}

    if not isfile('AcroRdrDC1901020064_MUI.exe'):
        wget('http://ardownload.adobe.com/pub/adobe/reader/win/AcrobatDC/1901020064/AcroRdrDC1901020064_MUI.exe','AcroRdrDC1901020064_MUI.exe',proxies=proxies)

    # Recover the last msp file
    for line in readftp("ftp://ftp.adobe.com/pub/adobe/reader/win/AcrobatDC/").split('\n'):
        if 'ftp' in line :
            if not 'misc' in line :
                realversion = line.rsplit(' ')[-1].replace('\r\n','').split('\r')[0]
        if 'misc' in line :
            break

    for line in readftp("ftp://ftp.adobe.com/pub/adobe/reader/win/AcrobatDC/%s" % realversion).split('\n'):
        if line.split('\r')[0].endswith('_MUI.msp'):
            filemsp = line.split('\r')[0].rsplit(' ')[-1]

    # Delete old msp file

    for f in glob.glob('*.msp') :
        if f != filemsp :
            remove_file(f)

    # Download the last msp file if not present
    if not isfile(filemsp):
        wget("http://ftp.adobe.com/pub/adobe/reader/win/AcrobatDC/%s/%s" % (realversion,filemsp),filemsp,proxies=proxies)


    #installation for recovery of the exact version
    print('Run install setup.exe')
    if uninstall_key_exists('{AC76BA86-7AD7-1036-7B44-AC0F074E4100}'):
        killalltasks(['AdobeARM.exe','AcroRd32.exe'])
        run(uninstall_cmd('{AC76BA86-7AD7-1036-7B44-AC0F074E4100}'))
    if installed_softwares('{AC76BA86-7AD7-FFFF-7B44-AC0F074E4100}'):
        run(r'"AcroRdrDC1901020064_MUI.exe" %s' % args,timeout=1200)
    run('msiexec.exe /p %s /norestart /quiet ALLUSERS=1 EULA_ACCEPT=YES' % filemsp,timeout=1200)

    vers = installed_softwares('{AC76BA86-7AD7-FFFF-7B44-AC0F074E4100}')[0]['version']

    #vers = realversion[:2] + '.' + realversion[2:-5] + '.' + realversion[-5:]

    control.version = '20' + vers + '-0'
    control.save_control_to_wapt()

def readftp(url):
    from urllib.request import urlopen
    sock = urlopen(url,timeout=60)
    htmlSource = sock.read()
    sock.close()
    return ensure_unicode(htmlSource)

